package de.hft.geotracker

import android.content.Intent
import android.os.Bundle
import androidx.fragment.app.Fragment
import android.widget.TextView
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response
import retrofit2.Retrofit
import retrofit2.converter.gson.GsonConverterFactory

/**
 * A simple [Fragment] subclass.
 */
class Login  : AppCompatActivity() {
    lateinit var login : TextView
    lateinit var reg : TextView
    lateinit var service : GeofenceService
    lateinit var token : JWToken

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_login)

        val retrofit = Retrofit.Builder()
            .baseUrl("http://plesk.icaotix.de:5000")
            .addConverterFactory(GsonConverterFactory.create())
            .build()
        service = retrofit.create(GeofenceService::class.java)

        login = findViewById(R.id.button_create_account)
        login.setOnClickListener {
            intent = Intent(this, MainActivity::class.java)
            login()
        }
        reg = findViewById(R.id.button_register)
        reg.setOnClickListener {
            register()
        }
    }

    private fun register() {
        val intent = Intent(this, Register::class.java)
        startActivity(intent)
    }

    private fun login() {
        val name = findViewById<TextView>(R.id.setting_input_username).text.toString()
        val pswd = findViewById<TextView>(R.id.input_password).text.toString()
        var call= service.login(ValuesUserLogin(name, pswd))

        call.enqueue(object : Callback<Void> {
            override fun onResponse(call: Call<Void>?, response: Response<Void>?) {
                if(response != null && response.isSuccessful) {
                        var headers = response.headers()
                        var authentication = headers.get("Authorization")

                        token = JWToken(authentication)
                        println(response.code())
                        println(token.token)

                        startActivity(intent)
                } else {
                    if (response != null) {
                        println(response.code())
                        Toast.makeText(this@Login, "Wrong Username or Password!", Toast.LENGTH_LONG).show()
                    } else {
                        println("Response is null")
                    }
                }
            }

            override fun onFailure(call: Call<Void>?, t: Throwable?) {
                println("Error: ${t.toString()}")
            }

        })
    }
}
